#ifndef __DLG_H__
#define __DLG_H__

#include <dir.h>

// Allegro gui dialogy

// SOUND DIALOG

int MIDIvol= 255,Samplevol=255;
SAMPLE *smp= NULL;

int mMIDIvol= MIDIvol;
int mSamplevol= Samplevol;


int my_slider_proc1(int msg,DIALOG* d,int c)
{
 if (d->d2!= mMIDIvol)
  {
   mMIDIvol= d->d2;
   set_volume(mSamplevol,mMIDIvol);
  }
 return d_slider_proc(msg,d,c);
}
int my_slider_proc2(int msg,DIALOG* d,int c)
{
 if (d->d2!= mSamplevol)
  {
   mSamplevol= d->d2;
   set_volume(mSamplevol,MIDIvol);
   if (smp) play_sample(smp,255,127,1000,FALSE);
  }
 return d_slider_proc(msg,d,c);
}

DIALOG SOUND_DLG[]=
{
 {d_shadow_box_proc,  220,  140,  200,  160,  0x7FFFFF,0x00007F,0,    0,       0,    0,    NULL},
 {d_button_proc,      240,  260,  60,   20,   0x7FFFFF,0x00007F,0,    D_EXIT,  0,    0,    "OK" },
 {d_button_proc,      340,  260,  60,   20,   0x7FFFFF,0x00007F,0,    D_EXIT,  0,    0,    "Cancel" },
 {d_text_proc,        240,  170,  60,   20,   0x7FFFFF,0x00007F,0,    0,       0,    0,    "MIDI:"},
 {d_text_proc,        240,  220,  60,   20,   0x7FFFFF,0x00007F,0,    0,       0,    0,    "Sample:"},
 {my_slider_proc1,    300,  160,  100,  20,   0x7F0000,0x00007F,0,    0,       255,  MIDIvol,  NULL},
 {my_slider_proc2,    300,  210,  100,  20,   0x007F00,0x00007F,0,    0,       255,  Samplevol,  NULL},
 {NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL},
};

// LOAD & SAVE DIALOG

#define MAX_SAVED 64

char *l_s_items[MAX_SAVED];
int l_s_list_size= 0;

char *foobar(int index, int *list_size)
{
 *list_size= l_s_list_size;
 return l_s_items[index];
}

/*int my_edit_proc(int msg, DIALOG *d, int c)
{
 return d_edit_proc(msg,d,c);
} */

int my_list_proc(int msg, DIALOG *d, int c)
{
 if (msg== MSG_CLICK)
  {
   strcpy((char*) d[1].dp,l_s_items[d->d1]);
   broadcast_dialog_message(MSG_DRAW,0);
  }
 if (msg== MSG_START)
  {
   ffblk fl;
   int index= 0;
   int done= findfirst("*.sav",&fl,FA_ARCH);
   while (!done)
   {
    if (index<MAX_SAVED)
     {
      l_s_items[index]= new char[16];
      strcpy(l_s_items[index],fl.ff_name);
      index++;
     } else break;
    done= findnext(&fl);
   }
   l_s_list_size= index;
  }
 if (msg== MSG_END)
  {
   for (;l_s_list_size>0;l_s_list_size--) delete[] l_s_items[l_s_list_size];
  }
 return d_list_proc(msg,d,c);
}

DIALOG LOAD_SAVE_DLG[]=
{
 {d_shadow_box_proc,  220,  140,  200,  160,  0x7FFFFF,0x00007F,0,    0,       0,    0,    NULL},
 {d_shadow_box_proc,  299,  169,  102,  10,   0x00FF00,0x00007F,0,    0,       0,    0,    NULL},
 {d_button_proc,      240,  260,  60,   20,   0x7FFFFF,0x00007F,0,    D_EXIT,  0,    0,    "OK" },
 {d_button_proc,      340,  260,  60,   20,   0x7FFFFF,0x00007F,0,    D_EXIT,  0,    0,    "Cancel" },
 {d_text_proc,        240,  170,  60,   20,   0x7FFFFF,0x00007F,0,    0,       0,    0,    "File:"},
 {my_list_proc,       240,  200,  160,  40,   0x9F0000,0x00007F,0,    0,       0,    0,    foobar},
 {d_edit_proc,        300,  170,  100,  20,   0x00FF00,0x00007F,0,    0,      12,    0,    "\0\0\0\0\0\0\0\0\0\0\0\0\0\0"},
 {NULL,                 0,    0,    0,   0,          0,       0,0,    0,       0,    0,    NULL},
};

// MESAGE_BOX

DIALOG MESSAGE_BOX[]=
{
 {d_shadow_box_proc,  200,  200,  240,  100,  0x7FFFFF,0x00007F,0,    0,       0,    0,    NULL},
 {d_button_proc,      290,  260,  60,   20,   0x7FFFFF,0x00007F,0,    D_EXIT,  0,    0,    "OK" },
 {d_text_proc,        220,  220,  180,  20,   0xAF0000,0x00007F,0,    0,       0,    0,    NULL},
 {d_text_proc,        220,  240,  180,  20,   0x00AF00,0x00007F,0,    0,       0,    0,    NULL},
 {NULL,                 0,    0,    0,   0,          0,       0,0,    0,       0,    0,    NULL},
};

void do_message_box(const char* caption,const char* text)
{
 MESSAGE_BOX[2].dp= (void*) caption;
 MESSAGE_BOX[3].dp= (void*) text;
 do_dialog(MESSAGE_BOX,-1);
}

#endif
