#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream.h>

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE -1
#endif

#include "vyraz.h"

double faktor(char *s);
double clen(char *s);
double vyraz(char* s);

double faktor(char *s)
{
 if (s[strlen(s)]== '$') return 0;

 double retval;

 if (s[0]== '(')
  {
   strcpy(s,&s[1]);
   retval= vyraz(s);
   strcpy(s,&s[1]);
  } else if (s[0]== '|')
  {
   strcpy(s,&s[1]);
   retval= vyraz(s);
   if (retval< 0) retval= -retval;
   strcpy(s,&s[1]);
  } else if (s[0]== 'S' &&s[1]== 'I' &&s[2]== 'N')
  {
   strcpy(s,&s[4]); // sin(
   retval= vyraz(s);
   retval= M_PI*retval/180;
   retval= sin(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'C' &&s[1]== 'O' &&s[2]== 'S')
  {
   strcpy(s,&s[4]);
   retval= vyraz(s);
   retval= M_PI*retval/180;
   retval= cos(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'T' &&s[1]== 'A' &&s[2]== 'N')
  {
   strcpy(s,&s[4]); // tan(
   retval= vyraz(s);
   if ((retval-90)/90== double(int((retval-90)/90)))
    { strcpy(s,"$"); return 0;}
   retval= M_PI*retval/180;
   retval= tan(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'C' &&s[1]== 'O' && s[2]== 'T' && s[3]== 'G')
  {
   strcpy(s,&s[5]); // cotg(
   retval= vyraz(s);
   if (retval/180== double(int(retval/180)))
    { strcpy(s,"$"); return 0;}
   retval= M_PI*retval/180;
   retval= 1/tan(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'E' && s[1]== 'X' && s[2]== 'P')
  {
   strcpy(s,&s[4]); // exp(
   retval= vyraz(s);
   retval= exp(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'L' && s[1]== 'O' && s[2]== 'G' && s[3]== '1' && s[4]== '0')
  {
   strcpy(s,&s[6]); // log10(
   retval= vyraz(s);
   if (retval<= 0)
    { strcpy(s,"$"); return 0;}
   retval= log10(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'L' && s[1]== 'O' && s[2]== 'G' && s[3]== '2')
  {
   strcpy(s,&s[5]); // log2(
   retval= vyraz(s);
   if (retval<= 0)
    { strcpy(s,"$"); return 0;}
   retval= log2(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'L' && s[1]== 'N')
  {
   strcpy(s,&s[3]); // ln(
   retval= vyraz(s);
   if (retval<= 0)
    { strcpy(s,"$"); return 0;}
   retval= log(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'L' && s[1]== 'O' && s[2]== 'G')
  {
   strcpy(s,&s[4]); // log(
   double _x= vyraz(s);
   strcpy(s,&s[1]);
   double _y= vyraz(s);
   if (_x<= 0 || _x== 1 || _y< 0)
    { strcpy(s,"$"); return 0;}
   retval= log(_y)/log(_x);
   strcpy(s,&s[1]);
  }else if (s[0]== 'P' && s[1]== 'O' && s[2]== 'W')
  {
   strcpy(s,&s[4]); // pow(
   double _x= vyraz(s);
   if (*s!= ',')
    { strcpy(s,"$"); return 0;}
   strcpy(s,&s[1]); // ,
   double _y= vyraz(s);
   retval= pow(_x,_y);
   if (retval== _x && _y!=1)
    { strcpy(s,"$"); return 0;}
   strcpy(s,&s[1]);
  }else if (s[0]== 'S' && s[1]== 'Q' && s[2]== 'R' && s[3]== 'T')
  {
   strcpy(s,&s[5]); // sqrt(
   retval= vyraz(s);
   if (sqrt<0)
    { strcpy(s,"$"); return 0;}
   retval= sqrt(retval);
   strcpy(s,&s[1]);
  }else if (s[0]== 'S' && s[1]== 'Q' && s[2]== 'R')
  {
   strcpy(s,&s[4]); // sqr(
   retval= vyraz(s);
   retval= retval*retval;
   strcpy(s,&s[1]);
  } else
  {
   int zap=0;     // zaporne c.
   if (s[0]== '+') strcpy(s,&s[1]); // unarni +
   else if (s[0]== '-') // unarni -
   {
    zap= 1;
    strcpy(s,&s[1]);
   }

   char poms[255];
   int i;

   for (i= 0;s[i]>='0' && s[i]<= '9' || s[i]== '.';i++) poms[i]=s[i];
   poms[i]= '\0';
   strcpy(s,&s[i]);
   retval= atof(poms);
   if (zap) retval= -retval;
  }
 return retval;
}

double clen(char *s)
{
 if (s[strlen(s)]== '$') return 0;

 double val;

 val= faktor(s);

 for (;s[0]== '*' || s[0]== '/';)
  {
   if (s[0]== '*')
    {
     strcpy(s,&s[1]);
     val= val*faktor(s);
    }
   else if (s[0]== '/')
    {
     strcpy(s,&s[1]);
     double fa= faktor(s);
     if (fa== 0)
      { strcat(s,"$"); return 0; }
     val= val/fa;
    }
  }
 return val;
}

double vyraz(char* s)
{
 if (s[strlen(s)]== '$') return 0;

 double val;

 val= clen(s);
 for (;s[0]== '+' || s[0]== '-';)
  {
   if (s[0]== '+')
    {
     strcpy(s,&s[1]);
     val= val+clen(s);
    }
   else if (s[0]== '-')
    {
     strcpy(s,&s[1]);
     val= val-clen(s);
    }
  }

 return val;
}

double evalute(const char* s,int& ok)
{
 char ps[1024];
 strcpy(ps,s);
 double hod= vyraz(ps);
 ok= TRUE;
 if (ps[0]!= '\0') ok= FALSE;
 if (ps[strlen(ps)]== '$') ok= FALSE;
 return hod;
}

int pocet_znaku(const char* s, char a)
{
 int pocet= 0;
 for (int i= 0;s[i]!= '\0';i++) if (s[i]== a) pocet++;
 return pocet;
}

int IsVyrazOK(const char* s)
{
 char ps[1024];
 strcpy(ps,s);
 int ok;
 ok= TRUE;
 if (pocet_znaku(s,'(')!= pocet_znaku(s,')')) return FALSE;
 vyraz(ps);
 if (ps[0]!= '\0') ok= FALSE;
 if (ps[strlen(ps)]== '$') ok= FALSE;
 return ok;
}

void ftoa(double x,char* s)
{
 sprintf(s,"%f",x);
}

char* argument(const char* s,double prom,int& ok)
{
 char pom[255];
 *pom= '\0';
 int lastx=0;
 memset(&pom,0,sizeof(pom));
 ok= TRUE;
 for (int i= 0;i<strlen(s);i++)
  {
   if (s[i]== 'x')
    {
     memcpy(&pom[strlen(pom)],&s[lastx],i-(lastx));
     ftoa(prom,&pom[strlen(pom)]);
     lastx= i+1;
    }
  }
 strcat(pom,&s[lastx]);

 char *ps= pom;

 return ps;
}


